<?php
/*
The following steps have to be carried out in order to generate and activate the acceptors own certificate and key pair:
1.
Generate an RSA private key with the following command (use a self chosen password for the field ownPassword): openssl genrsa des3 out priv.pem passout pass:ownPassword 1024
2.
The result of this is the priv.pem file. PEM files are intended for the storage of the private key and the public key. The file is saved as the default in the bin directory under the OpenSSL directory.
3.
Generate a certificate on the basis of the RSA private key (use the same password for the field ownPassword as in step 2): openssl req x509 new key priv.pem passin pass:ownPassword days 3650 out cert.cer
This command leads to a series of questions about the requestor. Enter the correct values. This relates among other things to the organization name. You need this organization name in some subsequent steps.
The result is the cert.cer file. CER files contain the certificate and the public key. The file is saved as the default in the bin directory under the OpenSSL directory.


4.
Copy the private key and the certificate to the same defined folder as the configuration file (see section 3.3).
5.
Configure the following parameters in the config.conf file; replace the value for PrivatekeyPass in ownPassword that you also used in step 2:
Privatekey=priv.pem PrivatekeyPass=ownPassword Privatecert=cert.cer
6.
Upload cert.cer to the test environment of the iDEAL Acquiring platform (via the iDEAL Dashboard).
7.
After positive verification by the iDEAL Service Desk (see Chapter Registration process of the iDEAL General information document): Upload cert.cer to the production environment of the iDEAL Acquiring platform (via the iDEAL Dashboard).
Anugrah

*/

if ($vars['test']=='true') 			$ms['url']	='ssl://idealtest.secure-ing.com:443/ideal/iDeal';
else 								$ms['url']	='ssl://ideal.secure-ing.com:443/ideal/iDeal';	
$validUntil							=date("Y-m-d\TH:i:s",(time()+3000)).':000Z';
$paymentType						='ideal';
$merchant_id						=$vars['merchant_id'];
$merchant_key						=$vars['merchant_key'];
$merchant_subid						=$vars['merchant_subid'];
$amount								=(preg_replace("/^0/",'',$order['total_amount'])*100);

// creating the hash step by step in an array so we can easily debug it if there is something wrong
$hash_array=array();
$hash_array[] = $merchant_key;
$hash_array[] = $merchant_id;
$hash_array[] = $merchant_subid;
$hash_array[] = $amount;
$hash_array[] = $order['orders_id'];
$hash_array[] = $paymentType;
$hash_array[] = $validUntil;
$orderid = $order['orders_id'];


// moved from includes/security/config.conf
// iDEAL Advanced Configuration
$ideal_adv_config['PRIVATEKEY']			= 'priv.pem';
//enter your password below
$ideal_adv_config['PRIVATEKEYPASS'] 	= $vars['private_key_pass'];
$ideal_adv_config['PRIVATECERT']		= 'cert.cer';
$ideal_adv_config['CERTIFICATE0']		= 'webserver.cer';
$ideal_adv_config['ACQUIRERURL']		= $ms['url'];
$ideal_adv_config['ACQUIRERTIMEOUT']	= 60;
//enter your merchant id below
$ideal_adv_config['MERCHANTID']			= $vars['merchant_id'];
$ideal_adv_config['SUBID']				= $vars['merchant_subid'];
//enter payment confirmation url
$ideal_adv_config['MERCHANTRETURNURL']	= 'http://'.$server['HTTP_HOST'].'/'.mslib_fe::typolink('','&tx_multishop_pi1[page_section]=psp_accepturl_ideal_ing_advanced');
$ideal_adv_config['EXPIRATIONPERIOD']	= 'PT60M';
//enter the path to the logfile below
//$ideal_adv_config['LOGFILE']			= '';
//$ideal_adv_config['TraceLevel']			= 'DEBUG,ERROR';


require_once(t3lib_extMgm::extPath('multishop').'scripts/front_pages/includes/psp_forms/classes/ideal_ing_advanced/iDEALConnector.php');
$issuerList = "";

// Uitgaan van een directory request.
$type = 0;

// In PHP altijd variabelen initialiseren.
$errorCode = 0;
$errorMsg = "";
$consumerMessage = "";

// Identificeert de knop die ingedrukt werd
$button = $post["ideal_action"];

// Initialiseren van de MPI schil.
// adjusted by widy 13/04/2011
$iDEALConnector = new iDEALConnector($ideal_adv_config);

if (!$post['IssuerID']) {
	// Acties uitvoeren voor een directory request
	$response = $iDEALConnector->GetIssuerList();
	
    if ($response->IsResponseError())
	{
		// Een fout is opgetreden.
		$errorCode = $response->getErrorCode();
		$errorMsg = $response->getErrorMessage();
		$consumerMessage = $response->getConsumerMessage();
		$type = 0;

	} else {
		// De response is valide en bevat de directory entries.
		// Deze uitpakken en in de HTML plaatsen.
		$IssuerList =& $response->getIssuerFullList();
		$trans = array (" " => "&nbsp");
		foreach ($IssuerList as $issuerName => $entry) 
		{
			$issuerList = $issuerList . '<option value="' . $entry->getIssuerID() .'">'
				. strtr(str_pad($entry->getIssuerID(), 20), $trans) . " "
				. $entry->getIssuerName() . "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
				. $entry->getIssuerListType() 
				;
		}
		$issuerList .= "</option>";
					
		$acquirerID = $response->getAcquirerID();
			
		// Doorgaan met de HTML tonen van een transactie request
		$type = 1;
	}
} 
else if ($button == "AcquirerTrxRequest") 
{
	// Behandelen van een Transactie request
	$entranceCode = '12345678';	
	$purchaseId = $orderid;
	$issuerId = $post["IssuerID"];
	$amount = $amount;
	$description = substr($server['HTTP_HOST'], 0, 10);
	$expirationPeriod = $ideal_adv_config['EXPIRATIONPERIOD'];
	$merchantReturnURL = $ideal_adv_config['MERCHANTRETURNURL'];

	// Opsturen van de request. De response staat in $response.
	$response = $iDEALConnector->RequestTransaction(
		$issuerId,
        $purchaseId,
        $amount,
        $description,
        $entranceCode,
        $expirationPeriod,
        $merchantReturnURL ); 

    if ($response->IsResponseError())
	{
		// Een fout is opgetreden.
		$errorCode = $response->getErrorCode();
		$errorMsg = $response->getErrorMessage();
		$consumerMessage = $response->getConsumerMessage();
		
		$type = 1;
	}
	else 
	{
		// De response bevat geen foutmelding.
		$acquirerID = $response->getAcquirerID();
		$issuerAuthenticationURL = $response->getIssuerAuthenticationURL();
		$transactionID = $response->getTransactionID();

		// Doorgaan met het status request scherm
		$type = 3;
	}
}

if ( $errorMsg != "" ) 
{
/*$content .= '<div class="error">
    Error code: ' . $errorCode . '<br>
    Error message destined for merchant audit logs: ' . $errorMsg . '<br>
    Order ID: '.$orderid.'<br>
	Consumer message destined for webshop visitor: ' . $consumerMessage . '<br>
    </div>';*/
}

if ($type == 0) 
{
    //$content .= 'Error';
}

if ($type == 1) 
{
$content .= '<form method="post" action="" id="pspform" name="pspform">
    <span class="descr">Select Issuer Bank: </span>
    <select name="IssuerID">
    '.$issuerList.'
    </select>
	<input type="hidden" name="ideal_action" value="AcquirerTrxRequest" />
	<input name ="Button" type="submit" value="Submit"></input>
    </form>';
}
if ($type == 3)
{
    // here we go putting some transaction data to tx_multishop_payment_transactions
	$GLOBALS['TYPO3_DB']->sql_query("INSERT INTO tx_multishop_payment_transactions (orders_id, transaction_id, psp, code, crdate, status) VALUES ('".$orderid."', '".$transactionID."', 'ing_advanced', '".$user_method['code']."', '".time()."', '0')");
	header('Location: ' . $issuerAuthenticationURL);
}
if ($type == 3 || $type == 4) 
{	// Type 3: Result of TrxRequest and Button of StatusRequest
    
	/*$content .= '<div class="form">
    <form action="" method="POST">
    <span class="explain">The status request queries the acquirer and issuer for the status of the payment.</span>
    <div class="input"><span class="descr">TransactionID: </span>
    <input name ="TransactionID" type="text" size="20" value="' . $transactionID . '"></input>
    <span class="explain">The unique identifier for the payment as received in the transaction response</span></div>
	<input type="hidden" name="ideal_action" value="AcquirerStatusRequest" />
    <input name="Button" type="submit" value="Submit"></input>
    </form>
    </div>';*/

}
?>